"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const when_exit_1 = __importDefault(require("when-exit"));
/**
 * copyright 2022 MIT
 * Mhammed Talhaouy
 *
 */
class Cursor {
    /**
     *
     * @param stream
     */
    constructor(stream = process.stdout) {
        this.stream = stream;
        this.visible = true;
        (0, when_exit_1.default)(this.show);
    }
    has() {
        return this.visible;
    }
    hide() {
        return this.toggle(false);
    }
    show() {
        return this.toggle(true);
    }
    toggle(force = !this.visible) {
        if (!this.stream.isTTY)
            return;
        this.visible = force;
        const command = force ? "\u001B[?25h" : "\u001B[?25l";
        this.stream.write(command);
    }
}
exports.default = Cursor;
